Range-v3 Range algorithms, views, and actions for the Standard Library |

Friends | Public Types | Public Member Functions | Public Attributes | List of all members
ranges::v3::sized_range< I, S > Struct Template Reference
Core
Inheritance diagram for ranges::v3::sized_range< I, S >:

## Friends
template<typename X , typename Y >
struct | sized_range

## Public Types
using | iterator = I
using | sentinel = S

## Public Member Functions
iterator | begin () const
sentinel | end () const
template<typename X , typename Y , int _concept_requires___LINE__ = 42, typename std::enable_if< (_concept_requires___LINE__==43)||(ConvertibleTo< I, X >()&&ConvertibleTo< S, Y >()), int >::type = 0>
constexpr | operator range< X, Y > () const
template<typename X , typename Y , int _concept_requires___LINE__ = 42, typename std::enable_if< (_concept_requires___LINE__==43)||(ConvertibleTo< I, X >()&&ConvertibleTo< S, Y >()), int >::type = 0>
constexpr | operator std::pair< X, Y > () const
sized_range & | operator= (sized_range< I, S > const &rng)
sized_range & | operator= (sized_range< I, S > &&rng)
template<typename X , typename Y , int _concept_requires___LINE__ = 42, typename std::enable_if< (_concept_requires___LINE__==43)||(Assignable< I &, X && >()&&Assignable< S &, Y && >()), int >::type = 0>
sized_range & | operator= (sized_range< X, Y > rng)
iterator_size_t< I > | size () const
| sized_range (sized_range< I, S > const &rng)
| sized_range (sized_range< I, S > &&rng)
template<typename X , typename Y , int _concept_requires___LINE__ = 42, typename std::enable_if< (_concept_requires___LINE__==43)||(ConvertibleTo< X, I >()&&ConvertibleTo< Y, S >()), int >::type = 0>
| sized_range (std::pair< X, Y > rng, iterator_size_t< I > size)
template<typename X , typename Y , int _concept_requires___LINE__ = 42, typename std::enable_if< (_concept_requires___LINE__==43)||(ConvertibleTo< X, I >()&&ConvertibleTo< Y, S >()), int >::type = 0>
| sized_range (range< X, Y > rng, iterator_size_t< I > size)
template<typename X , typename Y , int _concept_requires___LINE__ = 42, typename std::enable_if< (_concept_requires___LINE__==43)||(ConvertibleTo< X, I >()&&ConvertibleTo< Y, S >()), int >::type = 0>
| sized_range (sized_range< X, Y > rng)
| third (size)
| third (rng.third)
| third (rng.third)
Public Member Functions inherited from ranges::v3::view_interface< sized_range< I, S > >
range_reference_t< D > | back ()
| Access the last element in a range:
range_reference_t< D const > | back () const
constexpr bool | empty () const
range_reference_t< D > | front ()
| Access the first element in a range:
range_reference_t< D const > | front () const
constexpr | operator bool () const
| operator Container ()
| Implicit conversion to something that looks like a container.
| operator Container () const
constexpr bool | operator! () const
auto | operator[] (range_difference_t< D > n) -> decltype(std::declval< D & >().begin()[n])
| Simple indexing:
auto | operator[] (range_difference_t< D > n) const -> decltype(std::declval< D const & >().begin()[n])
auto | operator[] (detail::slice_bounds< range_difference_t< D >> offs) -> decltype(std::declval< Slice >()(std::declval< D & >(), offs.from, offs.to))
| Python-ic slicing:
auto | operator[] (detail::slice_bounds< range_difference_t< D >> offs) const -> decltype(std::declval< Slice >()(std::declval< D const & >(), offs.from, offs.to))
auto | operator[] (detail::slice_bounds< range_difference_t< D >, detail::from_end_< range_difference_t< D >>> offs) -> decltype(std::declval< Slice >()(std::declval< D & >(), offs.from, offs.to))
auto | operator[] (detail::slice_bounds< range_difference_t< D >, detail::from_end_< range_difference_t< D >>> offs) const -> decltype(std::declval< Slice >()(std::declval< D const & >(), offs.from, offs.to))
auto | operator[] (detail::slice_bounds< detail::from_end_< range_difference_t< D >>, detail::from_end_< range_difference_t< D >>> offs) -> decltype(std::declval< Slice >()(std::declval< D & >(), offs.from, offs.to))
auto | operator[] (detail::slice_bounds< detail::from_end_< range_difference_t< D >>, detail::from_end_< range_difference_t< D >>> offs) const -> decltype(std::declval< Slice >()(std::declval< D const & >(), offs.from, offs.to))
auto | operator[] (detail::slice_bounds< range_difference_t< D >, end_fn > offs) -> decltype(std::declval< Slice >()(std::declval< D & >(), offs.from, offs.to))
auto | operator[] (detail::slice_bounds< range_difference_t< D >, end_fn > offs) const -> decltype(std::declval< Slice >()(std::declval< D const & >(), offs.from, offs.to))
auto | operator[] (detail::slice_bounds< detail::from_end_< range_difference_t< D >>, end_fn > offs) -> decltype(std::declval< Slice >()(std::declval< D & >(), offs.from, offs.to))
auto | operator[] (detail::slice_bounds< detail::from_end_< range_difference_t< D >>, end_fn > offs) const -> decltype(std::declval< Slice >()(std::declval< D const & >(), offs.from, offs.to))
constexpr range_size_t< D > | size () const
| Access the size of the range, if it can be determined:

## Public Attributes
iterator_size_t< I > const | third
| third

## Additional Inherited Members
Protected Member Functions inherited from ranges::v3::view_interface< sized_range< I, S > >
sized_range< I, S > & | derived ()
sized_range< I, S >const & | derived () const

## Member Data Documentation

template<typename I, typename S>

ranges::v3::sized_range< I, S >::third

Initial value:
{}
{}
sized_range(I begin, S end, iterator_size_t<I> size)
: compressed_pair<I const, S const>{std::move(begin), std::move(end)}